#/bin/python3
import sys

cpu_index = int(sys.argv[1])
cpu_total = int(sys.argv[2])
job_index = 0

######## quick hack to re-compute failed runs
#failed = [106,107,108,109,110,111,115,116,117,118,124,125,127,128,129,130,131,62,65,66,68,76,77,78,79,90,91]
#try: failed.index(cpu_index)
#except: exit()
#cpu_index = failed[cpu_index]
########

from benchmark import device, benchmark
from activation import nn_size, modulize, activation, poly, cantor, cantor2, multi
from activation import sampler1d_smoothstep_repeat

import time
import matplotlib.pyplot as plt

import torch
import torch.nn as nn

π = torch.pi

epochs=256
# epochs=2

print(f"I am {cpu_index}/{cpu_total}")

σs = [
	["Softmax"    ,nn.Softmax()],
	["Softmin"    ,nn.Softmin()],
	["LogSigmoid" ,nn.LogSigmoid()],
	["LogSoftmax" ,nn.LogSoftmax()],
	["Softshrink" ,nn.Softshrink()],
	["Hardshrink" ,nn.Hardshrink()],
	["Hardsigmoid",nn.Hardsigmoid(inplace=True)],
	["Hardswish"  ,nn.Hardswish(inplace=True)],
	["Hardtanh"   ,nn.Hardtanh(inplace=True)],
	["identity"   ,nn.Identity()],
	["ReLU"       ,nn.ReLU(inplace=True)],
	["ReLU6"      ,nn.ReLU6(inplace=True)],
	["cantor2"    ,cantor2()],
	["cantor"     ,cantor()],
	["abs"        ,modulize(lambda x: torch.abs(x))],
	["Tanh"       ,nn.Tanh()],
	["SiLU"       ,nn.SiLU(inplace=True)],
	["RReLU"      ,nn.RReLU(inplace=True)],
	["PReLU"      ,nn.PReLU()],
	["Mish"       ,nn.Mish(inplace=True)],
	["ELU"        ,nn.ELU(inplace=True)],
	["SELU"       ,nn.SELU(inplace=True)],
	["GELU"       ,nn.GELU()],
	["CELU"       ,nn.CELU()],
	["Tanhshrink" ,nn.Tanhshrink()],
	# ["Threshold"  ,nn.Threshold(inplace=True)],
	["atan"       ,modulize(lambda x: torch.atan(x))],
	["sigmoid"    ,nn.Sigmoid()],
	["Softsign"   ,nn.Softsign()],
	["Softplus"   ,nn.Softplus()],
	["tan"        ,modulize(lambda x: torch.tan(x))],
	["sinc(x)"    ,modulize(lambda x: torch.sinc(x))],
	# ["sinc(2x)"   ,modulize(lambda x: torch.sinc(2*x))],
	["LeakyReLU=0.1",nn.LeakyReLU(0.1,inplace=True)],
	["LeakyReLU=0.5",nn.LeakyReLU(0.5,inplace=True)],
	["LeakyReLU=5.0",nn.LeakyReLU(5.0,inplace=True)],
	# ["fourier_1",modulize(lambda x: sum([A*torch.sin(2*π*ω*x+φ) for A,ω,φ in [ [0,0,π],[1,1,0],[1,2,0],[1,3,0], ]]))],
	# ["fourier_2",modulize(lambda x: sum([A*torch.sin(2*π*ω*x+φ) for A,ω,φ in [ [0,0,π],[1,1,π],[1,2,π/8],[-.2,3,π/4], ]]))],
	["multi_id_gelu"                     ,multi([nn.Identity(),nn.GELU(),])],
	["multi_id_gelu_sin"                 ,multi([nn.Identity(),nn.GELU(),modulize(lambda x: torch.sin(2*x)),])],
	["multi_id_gelu_sigmoid"             ,multi([nn.Identity(),nn.GELU(),nn.Sigmoid(),])],
	["multi_id_gelu_sigmoid_sin"         ,multi([nn.Identity(),nn.GELU(),nn.Sigmoid(),modulize(lambda x: torch.sin(2*x)),])],
	["multi_id_gelu_sigmoid_softmax_sin" ,multi([nn.Identity(),nn.GELU(),nn.Sigmoid(),nn.Softmax(),modulize(lambda x: torch.sin(2*x)),])],
	["multi_4softmax"                    ,multi(4*[nn.Softmax()])],
	["multi_12softmax"                   ,multi(12*[nn.Softmax()])],
	["multi_32softmax"                   ,multi(32*[nn.Softmax()])],
	["multi_64softmax"                   ,multi(64*[nn.Softmax()])],
	["multi_gelu"                        ,multi([nn.GELU(),])],
	["multi_gelu_sin"                    ,multi([nn.GELU(),modulize(lambda x: torch.sin(2*x)),])],
	["multi_gelu_sigmoid"                ,multi([nn.GELU(),nn.Sigmoid(),])],
	["multi_gelu_sigmoid_sin"            ,multi([nn.GELU(),nn.Sigmoid(),modulize(lambda x: torch.sin(2*x)),])],
	["multi_gelu_relu"                   ,multi([nn.GELU(),nn.ReLU()])],
]

# https://humphryscomputing.com/Notes/Neural/chaos.html
σs_crap = [
	# ["log(exp(-1)+abs(x))"        ,modulize(lambda x: torch.log(math.exp(-1)+torch.abs(x)))],
	# ["log(abs(x))"        ,modulize(lambda x: torch.log(torch.abs(x)))],
	# ["exp(x)"          ,modulize(lambda x: torch.exp(x))],
	# ["exp(x)+log(abs(x))" ,modulize(lambda x: torch.exp(x)+torch.log(torch.abs(x)))],
	# ["exp(sin(x)⁻¹)"  , modulize(lambda x: torch.exp(1/torch.sin(x)))],
	# ["exp(sin(πx)⁻¹)" , modulize(lambda x: torch.exp(1/torch.sin(π*x)))],
	# ["exp(sin(2πx)⁻¹)", modulize(lambda x: torch.exp(1/torch.sin(2*π*x)))],
	# ["exp(sin(3πx)⁻¹)", modulize(lambda x: torch.exp(1/torch.sin(3*π*x)))],
	# ["exp(x)-1"                   ,modulize(lambda x: torch.exp(x)-1)],
	# ["exp(x)-1+log(exp(-1)+abs(x))" ,modulize(lambda x: torch.exp(x)-1+torch.log(math.exp(-1)+torch.abs(x)))],
	# ["-exp(x)+1-log(exp(-1)+abs(x))" ,modulize(lambda x:-torch.exp(x)+1-torch.log(math.exp(-1)+torch.abs(x)))],
	# ["exp(sin(x)⁻¹)-1"  , modulize(lambda x: torch.exp(1/(1+torch.sin(    x))-1))],
	# ["exp(sin(1πx)⁻¹)-1", modulize(lambda x: torch.exp(1/(1+torch.sin(1*π*x))-1))],
	# ["exp(sin(2πx)⁻¹)-1", modulize(lambda x: torch.exp(1/(1+torch.sin(2*π*x))-1))],
	# ["exp(sin(3πx)⁻¹)-1", modulize(lambda x: torch.exp(1/(1+torch.sin(3*π*x))-1))],
	# # # ["sin-mess-a",modulize(lambda x: (2*torch.sin(3/x))+(3*torch.cos(5/x))+(4*torch.sin(6/x))+(1*torch.cos(3/x)))],
	# # # ["sin-mess-b",modulize(lambda x: torch.sin(3/x)*torch.sin(5/(1-x)))],
	# # # ["sin-mess-b",modulize(lambda x: torch.sin(3*x)*torch.sin(5/(1-x)))],
	# # # ["sin-mess-b",modulize(lambda x: torch.sin(2/(1-x)))],
	# # # ["sin-mess-b",modulize(lambda x: torch.sin(2*π/(.5-x**2)))],
	# # # ["sin-mess-b",modulize(lambda x: torch.sin(5/(1-x)))],
	# ["cos(8πx)⋅cos(4πx)",modulize(lambda x: torch.cos(8*π*x)*torch.cos(4*π*x))],
	# ["cos(8πx)⋅cos(4πx)⋅cos(2πx)",modulize(lambda x: torch.cos(8*π*x)*torch.cos(4*π*x)*torch.cos(2*π*x))],
	# ["cos((x-0.0)⁻¹)",modulize(lambda x: torch.cos(1/x))],
	# ["cos((x-0.5)⁻¹)",modulize(lambda x: torch.cos(1/(x-.5)))],
	# ["cos((x-1.0)⁻¹)",modulize(lambda x: torch.cos(1/(x-1)))],
	# ["cos((x-2.0)⁻¹)",modulize(lambda x: torch.cos(1/(x-2)))],
	# ["cos(5(x-2.0)⁻¹)",modulize(lambda x: torch.cos(5/(x-2)))],
	# ["crazy-cos",modulize(lambda x: torch.cos(5/(0.2+1+torch.cos(π*x))))],
	# # ["sin(8πx)⋅sin(4πx)",modulize(lambda x: torch.sin(8*π*x)*torch.sin(4*π*x))],
	# # ["sin(8πx)⋅sin(4πx)⋅sin(2πx)",modulize(lambda x: torch.sin(8*π*x)*torch.sin(4*π*x)*torch.sin(2*π*x))],
	# ["sin((x-0.0)⁻¹)",modulize(lambda x: torch.sin(1/x))],
	# # ["sin((x-0.5)⁻¹)",modulize(lambda x: torch.sin(1/(x-.5)))],
	# ["sin((x-1.0)⁻¹)",modulize(lambda x: torch.sin(1/(x-1)))],
	# # ["sin((x-2.0)⁻¹)",modulize(lambda x: torch.sin(1/(x-2)))],
	# # ["sin(5(x-2.0)⁻¹)",modulize(lambda x: torch.sin(5/(x-2)))],
	# ["cos(πx)⁻¹"  , modulize(lambda x: 1./(torch.cos(π*x)))],
	# ["sin(cos(πx)⁻¹)"  , modulize(lambda x: torch.sin(1./(torch.cos(π*x))))],
	# ["sin(cos(πx⋅2⁻¹)⁻¹)"  , modulize(lambda x: torch.sin(1./(torch.cos(π*x/2))))],
]

# plt.figure(figsize=(25,25))
# for i,[name,σ] in enumerate(σs):
#   x = torch.linspace(-2,2,2**12)
#   plt.subplot(6,6,i+1)
#   plt.plot(x,σ(x.clone()))

def benchmark_helper(name,σ,epochs):
	global job_index
	if job_index == cpu_index:
		print(f"I'm running job {job_index}")
		benchmark(name,σ,epochs)
	job_index = (job_index+1)%cpu_total

# random activations
for [name,σ] in σs: benchmark_helper(name,σ,epochs)

# sinus speed and phase experiment
for φ in torch.linspace(0,.5,2):
	for log10ν in torch.linspace(-1,0,7):
		benchmark_helper(
			f"sin(2π(νx+φ))-where-log10(ν)={log10ν:.3f}-and-φ={φ:.3f}",
			modulize(lambda x: torch.sin(2*π*(φ+(10**log10ν)*x))),
			epochs=epochs
		)

# TODO parametric sinus with tunable ω and φ

# polynom
for a in torch.linspace(-.25,.25,6):
	benchmark_helper(
		f"x+ax²-where-a={a:.2f}",
		modulize(poly([0,1,a])),
		epochs=epochs
	)

# perlin
for res in [2,4,8,32]:
	for scale in torch.linspace(-1,0,7):
		for seed in [0,1,2]:
			torch.manual_seed(seed)
			tex = torch.rand(res).to(device)
			benchmark_helper(
				f"perlin-where-res={res}-scale={scale:.3f}-seed={seed}",
				modulize(lambda x: sampler1d_smoothstep_repeat(tex,x/res*(10**scale))),
				epochs=epochs
			)

# polynom
#for a0         in torch.linspace(-1,1,5):
#	for a1     in torch.linspace(-1,1,5):
#		for a2 in torch.linspace(-1,0,5):
#			benchmark_helper(
#				f"ax⁰+bx¹+cx²-where-a={a0:.2f}-b={a1:.2f}-c={a2:.2f}",
#				modulize(poly([a0,a1,a2])),
#				epochs=epochs
#			)

# perlin
#for res in [2,3,4,6,8,16,32]:
#	for scale in torch.linspace(-2,2,7):
#		for seed in [0,1,2]:
#			torch.manual_seed(seed)
#			tex = torch.rand(res).to(device)
#			benchmark_helper(
#				f"perlin-where-res={res}-scale={scale:.3f}-seed={seed}",
#				modulize(lambda x: sampler1d_smoothstep_repeat(tex,x/res*(10**scale))),
#				epochs=epochs
#			)


# polynom
#for a0             in torch.linspace(-1,1,5):
#	for a1         in torch.linspace(-1,1,5):
#		for a2     in torch.linspace(-1,1,5):
#			for a3 in torch.linspace(-1,1,3):
#				benchmark_helper(
#					f"ax⁰+bx¹+cx²+dx³-where-a={a0:.3f}--b={a1:.3f}--c={a2:.3f}-d={a3:.3f}",
#					modulize(poly([a0,a1,a2,a3])),
#					epochs=epochs
#				)

# perlin
#for res in [2,4,6,8,16,32]:
#	for scale in torch.linspace(-2,2,5):
#		for seed in [0,1,2]:
#			torch.manual_seed(seed)
#			tex = torch.rand(res).to(device)
#			benchmark_helper(
#				f"perlin-where-res={res}-scale={scale:.3f}-seed={seed}",
#				modulize(lambda x: sampler1d_smoothstep_repeat(tex,x*(10**scale))),
#				epochs=epochs
#			)

